// kraidmonitor.cpp
// Copyright (C) 2011, Gerald Pichler
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

/*
For compiling with Debian install the following packages (maybe even more):
kdevelop, cmake, kdelibs-data, kdelibs5-dev, build-essentials
*/

// Here we avoid loading the header multiple times
#ifndef KRAIDMONITOR_HEADER
#define KRAIDMONITOR_HEADER
// We need the Plasma Applet headers
#include <KIcon>
#include <QTimer>

#include <Plasma/Applet>
#include <Plasma/Svg>

class QSizeF;

// Define our plasma Applet
class kraidmonitor : public Plasma::Applet
{
	Q_OBJECT
	public:
		// Basic Create/Destroy
		kraidmonitor(QObject *parent, const QVariantList &args);
		~kraidmonitor();

		// The paintInterface procedure paints the applet to screen
		void paintInterface(QPainter *painter,
			const QStyleOptionGraphicsItem *option,
			const QRect& contentsRect);
		void init();


	public slots:
		void updateArrayStatus();

	private:
		Plasma::Svg m_svg;
		KIcon g_icon, r_icon, y_icon;
		unsigned goodArray;
		QStringList devices;
		QTimer* threeSecond_timer;
};
 
// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(kraidmonitor, kraidmonitor)
#endif
